package Dislin;

use strict;
use vars qw($VERSION @ISA @EXPORT);

require Exporter;
require DynaLoader;

@ISA = qw(Exporter DynaLoader);

@EXPORT = qw(
     abs3pt  angle   arcell  areaf   autres  ax2grf  ax3len  axclrs  
     axends  axgit   axis3d  axslen  axsorg  axspos  axstyp  bargrp  
     barpos  bars    bartyp  barwth  basalf  bezier  bitsi2  bitsi4  
     box2d   box3d   center  chaang  chaspc  chawth  chnatt  chncrv  
     chndot  chndsh  chnpie  circle  circps  closfl  clpbor  clpmod  
     clpwin  clrcyc  clrmod  clswin  color   colran  colray  complx  
     concrv  congap  conlab  conmat  conmod  conn3d  connpt  conshd  
     contur  cross   crvmat  curv3d  curve   curve3  curvmp  curvx3  
     curvy3  dash    dashl   dashm   dattim  digits  disalf  disfin  
     disini  dot     dotl    duplx   dwgbut  dwgfil  dwglis  dwgmsg  
     dwgtxt  ellips  endgrf  erase   errbar  eushft  expzlb  fcha    
     filbox  filclr  filmod  fixspc  flab3d  flen    frame   frmess  
     gapcrv  getang  getbpp  getclr  getclp  getdig  getdsp  getfil  
     getgrf  gethgt  getind  getlab  getlen  getlev  getlin  getmfl  
     getor   getpag  getpat  getplv  getpos  getran  getres  getscl  
     getsp1  getsp2  getsym  gettcl  gettic  gettyp  getuni  getver  
     getvk   getvlt  getwid  getwin  getxid  grace   graf    graf3   
     graf3d  grafmp  grffin  grfini  grdpol  grid    grid3d  gridmp  
     gwgbox  gwgbut  gwgfil  gwglis  gwgscl  gwgtxt  height  helve   
     helves  histog  hname   hsvrgb  hsymbl  htitle  hwfont  hworig  
     hwpage  imgfin  imgini  inccrv  incfil  incmrk  intax   intcha  
     intlen  itmcat  itmcnt  itmstr  labclr  labdis  labels  labjus  
     labpos  labtyp  legclr  legend  legini  leglin  legopt  legpat  
     legpos  legtit  lfttit  lincyc  line    linesp  lintyp  linwid  
     lncap   lnjoin  lnmlt   logtic  mapmod  mappol  mapref  mapsph  
     marker  mdfmat  messag  metafl  mixalf  mixleg  moment  mpaepl  
     mplang  mplclr  mplpos  mplsiz  msgbox  mylab   myline  mypat   
     myvlt   namdis  name    namjus  neglog  newmix  newpag  nlmess  
     nlnumb  noarln  nobar   nobgd   nochek  noclip  nofill  nograf  
     nohide  noline  number  numfmt  numode  nxlegn  nxposn  nylegn  
     nyposn  nzposn  openfl  opnwin  origin  page    pagera  paghdr  
     pagmod  patcyc  penwid  pie     pieexp  piegrf  pielab  pievec  
     point   polcrv  pos2pt  pos3pt  posifl  projct  psfont  recfll  
     rectan  rel3pt  resatt  reset   revscr  rgbhsv  rgtlab  rimage  
     rlarc   rlarea  rlcirc  rlell   rline   rlmess  rlnumb  rlpie   
     rlpoin  rlrec   rlrnd   rlsec   rlsymb  rlvec   rndrec  rpixel  
     rpixls  rpxrow  rtiff   rvynam  scale   sclfac  sclmod  scrmod  
     sector  selwin  sendbf  serif   setbas  setclr  setexp  setfil  
     setgrf  setind  setmix  setpag  setres  setscl  setvlt  shdcha  
     shdcrv  shdeur  shdmap  shdmod  shdpat  shield  shlcir  shldel  
     shlell  shlind  shlpie  shlpol  shlrct  shlrec  shlres  shlsur  
     shlvis  simplx  skipfl  smxalf  solid   sortr1  sortr2  spline  
     splmod  strt3d  strtpt  surclr  surfce  surmat  surshd  sursze  
     survis  swapi2  swapi4  swgbox  swgbut  swgfil  swgfnt  swghlp  
     swgjus  swglis  swgmix  swgmod  swgmrg  swgoff  swgpop  swgpos  
     swgscl  swgsiz  swgtit  swgtxt  swgtyp  swgwin  swgwth  symbol  
     symfil  symrot  tellfl  thkcrv  ticks   ticlen  ticpos  tiforg  
     tifwin  timopt  titjus  title   titlin  titpos  trfco1  trfco2  
     trfco3  trfrel  trfres  trfrot  trfscl  trfshf  triplx  trmlen  
     txtjus  unit    upstr   vector  vectr3  view3d  vkxbar  vkybar  
     vkytit  wgapp   wgbas   wgbox   wgbut   wgcmd   wgfil   wgfin   
     wgini   wglab   wglis   wgok    wgpop   wgquit  wgltxt  wgpbut  
     wgscl   wgtxt   widbar  wimage  winmod  window  winid   winsiz  
     wintit  world   wpixel  wpixls  wpxrow  writfl  wtiff   x11mod  
     x2dpos  x3dabs  x3dpos  x3drel  xaxgit  xaxis   xaxlg   xaxmap  
     xcross  xdraw   xjdraw  xmove   xposn   y2dpos  y3dabs  y3dpos  
     y3drel  yaxgit  yaxis   yaxlg   yaxmap  ycross  yposn   z3dpos  
     zaxis   zaxlg   zscale
);
$VERSION = '6.3';

bootstrap Dislin $VERSION;
1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Dislin - Perl extension for data plotting

=head1 SYNOPSIS

  use Dislin;

=head1 DESCRIPTION

  DISLIN is a high-level and easy to use graphics library for
  displaying data as curves, bar graphs, pie charts, 3D-colour plots,
  surfaces, contours and maps. Several output formats are supported
  such as X11, VGA, PostScript, CGM, HPGL, TIFF and Prescribe. The library
  contains about 400 plotting and parameter setting routines and is
  available for several C, Fortran 77 and Fortran 90 compilers.

  FTP sites:

    ftp://ftp.gwdg.de/pub/grafik/dislin
    ftp://linhmi.mpae.gwdg.de/pub/dislin

  Home Page:

    http://www.mpae.gwdg.de/dislin/dislin.html

=head1 AUTHOR

  Helmut Michels
  Max-Planck-Institut fuer Aeronomie  Phone: +49 5556 979-334
  Postfach 20                         Fax  : +49 5556 979-240
  D-37189 Katlenburg-Lindau           Mail : michels@linax1.mpae.gwdg.de

=cut

