.TH DISLIN 1 "1 March 1994"
.SH NAME
dislin  -  A software package for displaying data

.SH DESCRIPTION
DISLIN is a library of FORTRAN and C routines for easy drawing
of axis systems, curves, legends, bars, pies, 3-D colour plots,                
surfaces, maps and contours.

The software package consist of two libraries (one for FORTRAN   
and one for C programs) and of the  utility  programs                

  clink    disaps   disdrv   disgif   dishlp   dishpj  disimg   disman
  dismov   disprv   distif   dlink

.SH  CLINK
Links C programs using DISLIN routines.

.SH SYNOPSIS
                clink    [option]   main

    option      is an optional parameter  that can  have one of
                the following values:  
           -c   for compiling programs before linking
           -r   for running programs after linking   
           -a   for compiling, linking and running programs.

    main        is the  name of  the main program  or may be in
                the form 'main,obj,lib' where obj is a field of 
                object files and lib a field of  library  files
                followed  by the  keyword /LIB.  Several  files
                must be separated by commas without any blanks.

Example:        clink  -a  myprg mylib.a

.SH DISAPS
  Converts an ASCII file to PostScript.

.SH SYNOPSIS
                 disaps   filename  output   [options]

  filename       is the name of the ASCII file.

  outout         is the name of the output file.  By default, the
                 name of the input file and the extension ps will
                 be used.

  options        is an optional field of keywords (see disaps).

.SH DISDRV
  Sends a plotfile to a device or converts the file format.

.SH SYNOPSIS
                  disdrv  filename[.met]  [device]  [options]

  filename        is the name of the plotfile.

  device          is a device name.
     =  CONS      Tektronix emulation (default)
     =  VT34      Tektronix emulation for VT330/VT340
     =  XWIN      X Window terminal
     =  XWND      X Window terminal (full screen mode)

     =  POST      converts a CGM or GKSLIN file to PostScript.
     =  PSCL      converts a CGM or GKSLIN file to coloured PostScript.
     =  KYOC      converts a CGM or GKSLIN file to a Kyocera file.
     =  HPGL      converts a CGM or GKSLIN file to HPGL.
     =  CGM       converts a GKSLIN file to a CGM file.
     =  GKSLIN    converts a CGM file to a GKSLIN file.

  options         is an optional field of keywords (see disdrv).   

.SH DISGIF
  Displays a  GIF file on the screen or sends it  to a PostScript
  printer.

.SH SYNOPSIS
                 disgif   filename[.gif]  [device]  [options]

  filename       is the name of the GIF file. 

  device         is the device name.

  options        is an optional field of keywords (see disgif).

.SH DISHLP
  Prints the description of a  DISLIN  routine on  the screen.

.SH SYNOPSIS
                 dishlp     [routine]  [options]

  routine        is the name of a DISLIN routine.

  options        is an optional field of keywords (see dishlp).   

.SH DISHPJ
  Sends a GKSLIN or CGM metafile to a printer using a raster graphics
  emulation (i.e. HP PCL).

.SH SYNOPSIS
                  dishpj  filename[.met]  [device]  [options]

  filename        is the name of the plotfile.

  device          is the name of the name.

  options         is an optional field of keywords (see dishpj).   

.SH DISIMG
  Displays an image created by DISLIN on the screen or sends it to
  a PostScript printer
 
.SH SYNOPSIS
                 disimg   filename[.img]  [device]  [options]

  filename       is the name of the image file.  The file  must be 
                 created with the routine rimage.

  device         is the device name.

  options        is an optional field of keywords (see disimg).

.SH DISMAN
  Prints an ASCII version of the DISLIN manual on the screen.

.SH SYNOPSIS
                 disman   [options]

  options        is an optional field of keywords (see disman).   

.SH DISMOV
  Displays a sequence of image files.
 
.SH SYNOPSIS
                 dismov   filename[.mov]  [device]  [options]

  filename       is the name of a data file where the filenames of
                 the images are stored (1 line for each filename).
                 The images must be created with the routine rimage.

  device         is the device name.

  options        is an optional field of keywords (see dismov).

.SH DISPRV
  Checks the use of DISLIN routines in a FORTRAN program. The type
  and dimension of parameters and the overlapping of  common block
  and routine  names  with internal  DISLIN  declarations  will be 
  checked.  

.SH SYNOPSIS
                 disprv     filename  [options]

  filename       describes the file containing the FORTRAN code.
                 The file extension '.FOR' can be omitted.

  options        is an optional field of keywords (see disprv).   

.SH DISTIF
  Displays a TIFF file created by DISLIN on the screen or sends it
  to a PostScript printer.

.SH SYNOPSIS
                 distif   filename[.tif]  [device]  [options]

  filename       is the name of the TIFF file.  The file  must be
                 created with the routine rtiff. 

  device         is the device name.

  options        is an optional field of keywords (see distif).

.SH DLINK
  Links FORTRAN programs using DISLIN routines.

.SH SYNOPSIS
                  dlink    [option]   main

      option      is an optional parameter  that can  have one of
                  the following values:  
             -c   for compiling programs before linking
             -r   for running programs after linking   
             -a   for compiling, linking and running programs.

      main        is the  name of  the main program  or may be in
                  the form 'main,obj,lib' where obj is a field of 
                  object files and lib a field of  library  files
                  followed  by the  keyword /LIB.  Several  files
                  must be separated by commas without any blanks.

  Example:        dlink  -a  myprg mylib.a

.SH EXAMPLES
  The program 'exampls' plots the examples of the  DISLIN manual.
  The files 'exampls.f', 'exampls.c' and  'exampls'  can be found
  in the DISLIN subdirectory (see $DISLIN).

.SH AUTHOR
DISLIN is written by  Helmut Michels, Tel. (05556) 979334,
                      Max-Planck-Institut  fuer Aeronomie,
                      D-37191 Katlenburg-Lindau, Germany,
                      E-mail: michels@linmpi.mpg.de
